---
title: PushManager.subscribe()
slug: Web/API/PushManager/subscribe
tags:
  - API
  - Experimental
  - Method
  - PushManager
  - Reference
  - Référence(2)
  - WebAPI
  - subscribe
---
<p>{{SeeCompatTable}}{{ApiRef("Push API")}}</p>

<p>The <strong><code>subscribe()</code></strong> method of the {{domxref("PushManager")}} interface subscribes to a push service.</p>

<p>It returns a {{jsxref("Promise")}} that resolves to a {{domxref("PushSubscription")}} object containing details of a push subscription. A new push subscription is created if the current service worker does not have an existing subscription.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">PushManager.subscribe(<em>options</em>).then(function(<em>pushSubscription</em>) { ... } );</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>options</code> {{optional_inline}}</dt>
 <dd>An object containing optional configuration parameters. It can have the following properties:
 <ul>
  <li><code>userVisibleOnly</code>: A boolean indicating that the returned push subscription will only be used for messages whose effect is made visible to the user.</li>
  <li><code>applicationServerKey</code>: A Base64-encoded {{domxref("DOMString")}} or {{domxref("ArrayBuffer")}} containing an <a href="https://en.wikipedia.org/wiki/Elliptic_Curve_Digital_Signature_Algorithm">ECDSA</a> P-256 public key that the push server will use to authenticate your application server. If specified, all messages from your application server must use the <a href="https://tools.ietf.org/html/rfc8292">VAPID</a> authentication scheme, and include a JWT signed with the corresponding private key. This key <em><strong>IS NOT</strong></em> the same ECDH key that you use to encrypt the data. For more information, see "<a href="https://blog.mozilla.org/services/2016/04/04/using-vapid-with-webpush/">Using VAPID with WebPush</a>".</li>
 </ul>

 <div class="note">
 <p><em><strong>Note: </strong>This parameter is required in some browsers like Chrome and Edge.</em></p>
 </div>
 </dd>
</dl>

<h3 id="Returns">Returns</h3>

<p>A {{jsxref("Promise")}} that resolves to a {{domxref("PushSubscription")}} object.</p>

<h2 id="Example">Example</h2>

<pre class="brush: js">this.onpush = function(event) {
  console.log(event.data);
  // From here we can write the data to IndexedDB, send it to any open
  // windows, display a notification, etc.
}

navigator.serviceWorker.register('serviceworker.js');

// Use serviceWorker.ready to ensure that you can subscribe for push
navigator.serviceWorker.ready.then(
  function(serviceWorkerRegistration) {
    var options = {
      userVisibleOnly: true,
      applicationServerKey: applicationServerKey
    };
    serviceWorkerRegistration.pushManager.subscribe(options).then(
      function(pushSubscription) {
        console.log(pushSubscription.endpoint);
        // The push subscription details needed by the application
        // server are now available, and can be sent to it using,
        // for example, an XMLHttpRequest.
      }, function(error) {
        // During development it often helps to log errors to the
        // console. In a production environment it might make sense to
        // also report information about errors back to the
        // application server.
        console.log(error);
      }
    );
  });</pre>

<h3 id="Responding_to_user_gestures">Responding to user gestures</h3>

<p><code>subscribe()</code> calls should be done in response to a user gesture, such as clicking a button, for example:</p>

<pre class="brush: js">btn.addEventListener('click', function() {
  serviceWorkerRegistration.pushManager.subscribe(options)
  .then(function(pushSubscription) {
    // handle subscription
  });
})</pre>

<p>This is not only best practice — you should not be spamming users with notifications they didn't agree to — but going forward browsers will explicitly disallow notifications not triggered in response to a user gesture. Firefox is already doing this from version 72, for example.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Push API', '#dom-pushmanager-subscribe', 'subscribe()')}}</td>
   <td>{{Spec2('Push API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>
<div>

<p>{{Compat("api.PushManager.subscribe")}}</p>
</div>
</div>
